/*
 * FixedAllocator.cpp
 *
 *  Created on: Feb 22, 2011
 *      Author: lipari
 */

#include "FixedAllocator.h"

using namespace std;

FixedAllocator::FixedAllocator(size_t s, int nelem)
{
	array = new char[s*nelem];
	for (int i=0; i<nelem; ++i) freepos.push(array+i*s);
}

FixedAllocator::~FixedAllocator()
{
	delete array;
}

void *FixedAllocator::alloc() throw(bad_alloc)
{
	if (freepos.empty()) throw bad_alloc();
	void *p = freepos.top();
	freepos.pop();
	return p;
}

void FixedAllocator::free(void *p)
{
	freepos.push((char *)p);
}
