//============================================================================
// Name        : overload_new.cpp
// Author      : Giuseppe Lipari
// Version     :
// Copyright   : c
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <stack>
#include <exception>
#include "FixedAllocator.h"
using namespace std;

// Esecizio da svolgere
// - specializzare new e delete per la class A
// - scrivere un semplice test per provare la funzionalità
//   --- specifica: che si fa se finisce la memoria?

#define NELEM 3

stack<char *> & getStack();

class MyClass {
public:
	int a, b;
	MyClass(int i) : a(i), b(0) { cout << "MyClass()" << endl; }
	~MyClass() { cout << "~MyClass()" << endl; }
	void* operator new(size_t s) throw(bad_alloc) {
		cout << "Allocando " << endl;
		if (getStack().empty()) throw bad_alloc();
		void *p = getStack().top();
		getStack().pop();
		return p;
	}
	void operator delete(void* p) {
		cout << "Sto deallocando l'elemento: "
			 << static_cast<MyClass *>(p)->a << endl;
		getStack().push((char *)p);
		return;
	}
};

stack<char *> & getStack()
{
	static char array[NELEM * sizeof(MyClass)];
	static stack<char *> free;
	static bool init = false;

	if (!init) {
		for (int i=0; i<NELEM; i++)
			free.push(array+i*sizeof(MyClass));
		init = true;
	}
	return free;
}

class A {
	static FixedAllocator *allocator;
	int i;
public:
	A(int ii) : i(ii) {
		cout << "Costruttore di A: " << i << endl;
	}
	~A() {
		cout << "Distruttore di A" << endl;
	}
	void* operator new(size_t s) throw(bad_alloc) {
		return allocator->alloc();
	}
	void operator delete(void* p) {
		allocator->free(p);
	}
};

FixedAllocator * A::allocator = new FixedAllocator(sizeof(A), 5);

int main() {
/*	MyClass *p = 0, *q = 0, *pp = 0, *qq = 0;
	try {
		p = new MyClass(1);
		q = new MyClass(2);
		pp = new MyClass(3);
		qq = new MyClass(4);
	} catch (exception &e) {
		cerr << "Eccezione! non riesco ad allocare!" << endl;
	}

	delete q;
	delete p;
	delete pp;
	delete qq;*/

	A *p=0, *q=0;

	p = new A(1);
	q = new A(2);

	delete p;
	delete q;

	return 0;
}
